#include <iostream>

using namespace std;

// Konstansok és típusok
const int MAXN = 10;
const int MAXDB = 10000000;
typedef int Permutacio[MAXN];
typedef Permutacio PermutacioSorozat[MAXDB];

// Változók
int N;
int Db;
PermutacioSorozat Y;

void Beolvasas(int &N) {
  clog << "N (N<10) = ";
  cin >> N;
}

bool Volt(const int i, const int j, const Permutacio x) {
  int k = 1;
  while (k < i and x[k - 1] != j) {
    k++;
  }
  return k < i;
}

void Osszes_sorrend(const int i, const int N, int &Db, PermutacioSorozat Y, Permutacio x) {
  if (i > N) {
    for (int j = 0; j < N; j++) {    // y[db] = x;
      Y[Db][j] = x[j];
    }
    Db++;
  } else {
    for (int j = 1; j <= N; j++) {
      if (!Volt(i, j, x)) {
        x[i - 1] = j;
        Osszes_sorrend(i + 1, N, Db, Y, x);
      }
    }
  }
}

void Megoldas(const int N, int &Db, PermutacioSorozat Y) {
  Permutacio x;
  Db = 0;
  Osszes_sorrend(1, N, Db, Y, x);
}

void Kiiras(const int N, const int Db, const PermutacioSorozat Y) {
  for (int i = 0; i < Db; i++) {
    for (int j = 0; j < N; j++) {
      cout << Y[i][j] << " ";
    }
    cout << endl;
  }
}

int main() {
  
  Beolvasas(N);
  Megoldas(N, Db, Y);
  Kiiras(N, Db, Y);
  
  return 0;
}